//  Banco de registradores (R0..R15) - TODOS OS 16 REGISTRADORES SAO USADOS
#ifndef _bcregs_h
#define _bcregs_h

#include "reg16.h"

SC_MODULE(bc_regs) {

  sc_in< bool > clock, reset, wreg, ms2;
  sc_in< sc_uint<16> > inREG, ir;

  sc_out< sc_uint<16> > source1, source2;

//  sc_signal< sc_uint<16> > r[16]; // Sada dos registradores
  sc_signal< sc_uint<16> > r_i_0; // Sada dos registradores
  sc_signal< sc_uint<16> > r_i_1; // Sada dos registradores
  sc_signal< sc_uint<16> > r_i_2; // Sada dos registradores
  sc_signal< sc_uint<16> > r_i_3; // Sada dos registradores
  sc_signal< sc_uint<16> > r_i_4; // Sada dos registradores
  sc_signal< sc_uint<16> > r_i_5; // Sada dos registradores
  sc_signal< sc_uint<16> > r_i_6; // Sada dos registradores
  sc_signal< sc_uint<16> > r_i_7; // Sada dos registradores
  sc_signal< sc_uint<16> > r_i_8; // Sada dos registradores
  sc_signal< sc_uint<16> > r_i_9; // Sada dos registradores
  sc_signal< sc_uint<16> > r_i_10; // Sada dos registradores
  sc_signal< sc_uint<16> > r_i_11; // Sada dos registradores
  sc_signal< sc_uint<16> > r_i_12; // Sada dos registradores
  sc_signal< sc_uint<16> > r_i_13; // Sada dos registradores
  sc_signal< sc_uint<16> > r_i_14; // Sada dos registradores
  sc_signal< sc_uint<16> > r_i_15; // Sada dos registradores
//  sc_signal< bool > wen[16];    // Enable dos regitradores
  sc_signal< bool > wen_i_0;
  sc_signal< bool > wen_i_1;
  sc_signal< bool > wen_i_2;
  sc_signal< bool > wen_i_3;
  sc_signal< bool > wen_i_4;
  sc_signal< bool > wen_i_5;
  sc_signal< bool > wen_i_6;
  sc_signal< bool > wen_i_7;
  sc_signal< bool > wen_i_8;
  sc_signal< bool > wen_i_9;
  sc_signal< bool > wen_i_10;
  sc_signal< bool > wen_i_11;
  sc_signal< bool > wen_i_12;
  sc_signal< bool > wen_i_13;
  sc_signal< bool > wen_i_14;
  sc_signal< bool > wen_i_15;

  reg16 *reg[16];         // Registradores do banco

  void out_source1();
  void out_source2();
  void decodificador();

  SC_CTOR(bc_regs) {
    SC_METHOD(out_source1);
      sensitive << ir;
      sensitive << r_i_0 << r_i_1 << r_i_2 << r_i_3 << r_i_4 << r_i_5 << r_i_6 << r_i_7;
      sensitive << r_i_8 << r_i_9 << r_i_10 << r_i_11 << r_i_12 << r_i_13 << r_i_14 << r_i_15;
//      sensitive << r[0] << r[1] << r[2] << r[3] << r[4] << r[5] << r[6] << r[7];
//      sensitive << r[8] << r[9] << r[10] << r[11] << r[12] << r[13] << r[14] << r[15];

    SC_METHOD(out_source2);
      sensitive << ms2 << ir;
      sensitive << r_i_0 << r_i_1 << r_i_2 << r_i_3 << r_i_4 << r_i_5 << r_i_6 << r_i_7;
      sensitive << r_i_8 << r_i_9 << r_i_10 << r_i_11 << r_i_12 << r_i_13 << r_i_14 << r_i_15;
//      sensitive << r[0] << r[1] << r[2] << r[3] << r[4] << r[5] << r[6] << r[7];
//      sensitive << r[8] << r[9] << r[10] << r[11] << r[12] << r[13] << r[14] << r[15];

    SC_METHOD(decodificador);
    sensitive << ir << wreg;


    // Instnciao dos registradores
    reg[0] = new reg16("reg0");
    reg[0]->clock(clock);
    reg[0]->reset(reset);
    reg[0]->ce(wen_i_0);
    reg[0]->D(inREG);
    reg[0]->Q(r_i_0);

    reg[1] = new reg16("reg1");
    reg[1]->clock(clock);
    reg[1]->reset(reset);
    reg[1]->ce(wen_i_1);
    reg[1]->D(inREG);
    reg[1]->Q(r_i_1);

    reg[2] = new reg16("reg2");
    reg[2]->clock(clock);
    reg[2]->reset(reset);
    reg[2]->ce(wen_i_2);
    reg[2]->D(inREG);
    reg[2]->Q(r_i_2);

    reg[3] = new reg16("reg3");
    reg[3]->clock(clock);
    reg[3]->reset(reset);
    reg[3]->ce(wen_i_3);
    reg[3]->D(inREG);
    reg[3]->Q(r_i_3);

    reg[4] = new reg16("reg4");
    reg[4]->clock(clock);
    reg[4]->reset(reset);
    reg[4]->ce(wen_i_4);
    reg[4]->D(inREG);
    reg[4]->Q(r_i_4);

    reg[5] = new reg16("reg5");
    reg[5]->clock(clock);
    reg[5]->reset(reset);
    reg[5]->ce(wen_i_5);
    reg[5]->D(inREG);
    reg[5]->Q(r_i_5);

    reg[6] = new reg16("reg6");
    reg[6]->clock(clock);
    reg[6]->reset(reset);
    reg[6]->ce(wen_i_6);
    reg[6]->D(inREG);
    reg[6]->Q(r_i_6);

    reg[7] = new reg16("reg7");
    reg[7]->clock(clock);
    reg[7]->reset(reset);
    reg[7]->ce(wen_i_7);
    reg[7]->D(inREG);
    reg[7]->Q(r_i_7);

    reg[8] = new reg16("reg8");
    reg[8]->clock(clock);
    reg[8]->reset(reset);
    reg[8]->ce(wen_i_8);
    reg[8]->D(inREG);
    reg[8]->Q(r_i_8);

    reg[9] = new reg16("reg9");
    reg[9]->clock(clock);
    reg[9]->reset(reset);
    reg[9]->ce(wen_i_9);
    reg[9]->D(inREG);
    reg[9]->Q(r_i_9);

    reg[10] = new reg16("reg10");
    reg[10]->clock(clock);
    reg[10]->reset(reset);
    reg[10]->ce(wen_i_10);
    reg[10]->D(inREG);
    reg[10]->Q(r_i_10);

    reg[11] = new reg16("reg11");
    reg[11]->clock(clock);
    reg[11]->reset(reset);
    reg[11]->ce(wen_i_11);
    reg[11]->D(inREG);
    reg[11]->Q(r_i_11);

    reg[12] = new reg16("reg12");
    reg[12]->clock(clock);
    reg[12]->reset(reset);
    reg[12]->ce(wen_i_12);
    reg[12]->D(inREG);
    reg[12]->Q(r_i_12);

    reg[13] = new reg16("reg13");
    reg[13]->clock(clock);
    reg[13]->reset(reset);
    reg[13]->ce(wen_i_13);
    reg[13]->D(inREG);
    reg[13]->Q(r_i_13);

    reg[14] = new reg16("reg14");
    reg[14]->clock(clock);
    reg[14]->reset(reset);
    reg[14]->ce(wen_i_14);
    reg[14]->D(inREG);
    reg[14]->Q(r_i_14);

    reg[15] = new reg16("reg15");
    reg[15]->clock(clock);
    reg[15]->reset(reset);
    reg[15]->ce(wen_i_15);
    reg[15]->D(inREG);
    reg[15]->Q(r_i_15);
  }
};

#endif
