#include <systemc.h>
#include <stdio.h>
#include <stdlib.h>

#define TAM	60000

void wait_ciclos( int ciclos ) {	// tranca a execuo
	for ( int i=0; i<ciclos; i++)
		wait();
}

void load_ram(sc_uint<16> *ram, char *obj) {

	FILE *arq;
	char str[4];
	sc_uint<16> addr_data[2];
	sc_uint<4> caracter[4];


	if ( (arq = fopen(obj,"rt")) == NULL ) {
		printf("Erro na abertura do arquivo '%s'.\n",obj);
		exit(0);
	}

	while ( !feof(arq) ) {
		for (int b=0; b<2; b++) {
			fscanf (arq,"%s",str);
			if ( feof(arq) ) break;
			for(int a=0; a<4; a++) {
				switch(str[a]) {
					case '0':
					case '1':
					case '2':
					case '3':
					case '4':
					case '5':
					case '6':
					case '7':
					case '8':
					case '9':
						caracter[a] = str[a]-48;
					break;

					case 'A':
					case 'B':
					case 'C':
					case 'D':
					case 'E':
					case 'F':
						caracter[a] = str[a]-('A'-10);
					break;

					case 'a':
					case 'b':
					case 'c':
					case 'd':
					case 'e':
					case 'f':
							caracter[a] = str[a]-('a'-10);
					break;
				}
			}
			addr_data[b].range(15,12) = caracter[0];
			addr_data[b].range(11,8) = caracter[1];
			addr_data[b].range(7,4) = caracter[2];
			addr_data[b].range(3,0) = caracter[3];
		}
		ram[addr_data[0]] = addr_data[1];
	}

	fclose(arq);

}

SC_MODULE(sinais) {

	sc_in< bool > clock, ce, rw;
	sc_in< sc_uint<16> > addr;
	sc_in< sc_uint<16> > datain;

	sc_out < bool > reset, wait_r8;
	sc_out< sc_uint<16> > dataout;



	int bordas;

	sc_uint<16> ram[TAM];

	void mem();
	void rst();

	SC_CTOR(sinais) {
		SC_THREAD(rst);
		sensitive << clock.pos();

		SC_METHOD(mem);
		sensitive << ce << rw << addr; //  << datain
		sensitive << clock;

		//load_ram(ram,"somavetr8.txt");
		ram[0] = 0x7110; 	// LDL		R1,10h
		ram[1] = 0xB017; 	// LDSP		R1
		ram[2] = 0x7105;	// LDL 		R1,05h
		ram[3] = 0xC01B;	// JSR		R1
		ram[4] = 0xB006;	// HALT
		ram[5] = 0xB008;	// RTS


		/* ram[0] = 0x4000;	//          xor r0, r0, r0  ; zera o registrador 0
		ram[1] = 0x7113;	//	        ldl r1,#n
		ram[2] = 0x8100;	//	        ldh r1,#n       ; busca o endereo do la
		ram[3] = 0x9110;	//	        ld  r1, r1,r0   ; grava em r1 o contedo
		ram[4] = 0x7214;	//	        ldl r2,#vet1
		ram[5] = 0x8200;	//	        ldh r2,#vet1
		ram[6] = 0x7319;	//	        ldl r3,#vet2
		ram[7] = 0x8300;	//	        ldh r3,#vet2
		ram[8] = 0x741E;	//	        ldl r4,#vet3
		ram[9] = 0x8400;	//	        ldh r4,#vet3    ; ponteiros para os veto
		ram[10] = 0x9502;	//	loop:   ld r5,r0,r2
		ram[11] = 0x9603;	//	        ld r6,r0,r3     ; busca um elemento de c
		ram[12] = 0x0665;	//	        add r6, r6,r5   ; faz a soma destes elem
		ram[13] = 0xA604;	//	        st  r6,r0,r4    ; grava na memria o val
		ram[14] = 0x5001;	//	        addi r0,#01h    ; incrementa o deslocame
		ram[15] = 0x6101;	//	        subi r1,#01h    ; decrementa o numero de
		ram[16] = 0xE401;	//	        jmpzd  #fim
		ram[17] = 0xD3F8;	//	        jmpd   #loop
		ram[18] = 0xB006;	//	fim:    halt
		ram[19] = 0x0005;	//	N:    DB #0005H
		ram[20] = 0x0001;	//	vet1: DB #0001H, #2305H, #AB3EH, #6159H, #3334H
		ram[21] = 0x2305;	//
		ram[22] = 0xAB3E;	//
		ram[23] = 0x6159;	//
		ram[24] = 0x3334;	//
		ram[25] = 0x5001;	//	vet2: DB #5001H, #00FFH, #FFFFH, #3840H, #2221H
		ram[26] = 0x00FF;	//
		ram[27] = 0xFFFF;	//
		ram[28] = 0x3840;	//
		ram[29] = 0x2221;	//
		ram[30] = 0x0000;	//  vet3: DB #0000H */
	}
};

void sinais::mem() {	// rw = 0: write
						// rw = 1: read

	unsigned int ad = addr.read().to_int();

	if ( ce.read() && rw.read() && ad<TAM && ad>=0 && (clock.read()==true))
		dataout.write(ram[ad]);

	else if ( ce.read() && !rw.read() && ad<TAM && ad>=0 && (clock.read()==false))
		ram[ad] = datain.read();

}


void sinais::rst() {

	reset = true;
	wait(5, SC_NS);
	reset = false;
}
